---
title: Binary strings
slug: Web/API/DOMString/Binary
tags:
  - DOM
  - JavaScript
  - JavaScript typed arrays
  - Reference
  - String
---
<p>{{jsxref("String", "JavaScript strings")}} are UTF-16 encoded strings. This means that each code unit requires two bytes of memory and is able to represent <code>65535</code> different code points. A subset of these strings is represented by UTF-16 strings containing only ASCII characters (i.e., characters whose code point does not exceed <code>127</code>). For instance, the string <code>"Hello world!"</code> belongs to the ASCII subset, while the string <code>"ÀÈÌÒÙ"</code> does not. A <strong>binary string</strong> is a concept similar to the ASCII subset, but instead of limiting the range to <code>127</code>, it allows code points until <code>255</code>. Its purpose however is not to represent characters, but binary data. The size of the data so represented is twice as big as it would be in normal binary format, however this will not be visible to the final user, since the length of JavaScript strings is calculated using two bytes as the unit.</p>

<p>Binary strings are not part of the JavaScript language design. However at least one native function requires binary strings as its input, {{domxref("WindowBase64.btoa","btoa()")}}: invoking it on a string that contains codepoints greater than <code>255</code> will cause a <code>Character Out Of Range</code> error.</p>

<p>The reason that brought to use UTF-16 code units as placeholders for <code>uint8</code> numbers is that as web applications become more and more powerful (adding features such as audio and video manipulation, access to raw data using WebSockets, and so forth) it has become clear that there are times when it would be helpful for JavaScript code to be able to quickly and easily manipulate raw binary data.</p>

<p>In the past, this had to be simulated by treating the raw data as a <a href="/en-US/docs/JavaScript/Reference/Global_Objects/String" title="JavaScript/Reference/Global Objects/String">string</a> and using the <a href="/en-US/docs/JavaScript/Reference/Global_Objects/String/charCodeAt" title="JavaScript/Reference/Global Objects/String/charCodeAt"><code>charCodeAt()</code></a> method to read the bytes from the data buffer (i.e., using binary strings). However, this is slow and error-prone, due to the need for multiple conversions (especially if the binary data is not actually byte-format data, but, for example, 32-bit integers or floats).</p>

<p><a href="/en-US/docs/Web/JavaScript/Typed_arrays">JavaScript typed arrays</a> provide a mechanism for accessing raw binary data much more efficiently.</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Typed_arrays">Typed arrays</a></li>
 <li><a href="/en-US/docs/Web/API/DOMString" title="/en-US/docs/Web/API/DOMString/Binary"><code>DOMString</code></a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/String" title="/en-US/docs/Web/API/DOMString">String</a></li>
</ul>
